function [Rbar,D,F]=rgindscal3(N2,N3)
% [Rbar,D,F]=rgindscal3(N2,N3)
% P.Comon, 29 June 2006.
% Rbar is the generic rank of tensors of order 3 and dimensions (N2,N2,N3) 
% with symmetric slices across the two first modes
% and D is the dimension of the whole tensor space
% F is the dimension of the variety of solutions
% if a norm constraint is imposed on K-1 loading vectors in each term, F=Rbar*(2*N2+N3-2)-D
% rmin is a lower bound on the generic rank, if known. The default is 1.
% Call:
% for I=2:10, for J=2:5, M(I-1,J-1)=rgindscal3(J,I);end;end;M

I2=eye(N2,N2);I3=eye(N3,N3);JAC=[];

 rankold=0;ranknew=1;
 while ranknew>rankold,
  b=randn(1,N2);c=randn(1,N3);
  JAC=[JAC;kron(I2,kron(b,c));kron(b,kron(I2,c));kron(b,kron(b,I3))];
 temp=ranknew;ranknew=rank(JAC);
% temp=ranknew;[Q,U]=gsm(JAC);ranknew=rank(U);
 fprintf('ranknew=%i\n',ranknew)
 rankold=temp;
 end;
 D=ranknew;


[lign,col]=size(JAC);Rbar=lign/(2*N2+N3)-1;F=Rbar*(N2+N3-1)-D;

